package djmil.cordacheckers.cordaclient.dao;

import java.util.List;
import java.util.Map;
import java.util.UUID;

public record GameView(
    Status status,

    Stone.Color myColor,
    String opponentName,
    
    Map<Integer, Stone> board,
    Integer moveNumber,
    List<Integer> previousMove,

    String message,
    UUID uuid
) {
    public static enum Status {
        GAME_PROPOSAL_WAIT_FOR_OPPONENT,
        GAME_PROPOSAL_WAIT_FOR_YOU,
        GAME_PROPOSAL_REJECTED,
        GAME_PROPOSAL_CANCELED,

        GAME_BOARD_WAIT_FOR_OPPONENT,
        GAME_BOARD_WAIT_FOR_YOU,

        DRAW_REQUEST_WAIT_FOR_OPPONENT,
        DRAW_REQUEST_WAIT_FOR_YOU,

        GAME_RESULT_YOU_WON,
        GAME_RESULT_YOU_LOOSE,
        GAME_RESULT_DRAW;
    }
    
    public final static Map<Integer, Stone> defaultGameBoard =  Map.ofEntries(
        // Inspired by Checkers notation rules: https://www.bobnewell.net/nucleus/checkers.php
        Map.entry( 1, new Stone(Stone.Color.BLACK, Stone.Type.MAN)),
        Map.entry( 2, new Stone(Stone.Color.BLACK, Stone.Type.MAN)),
        Map.entry( 3, new Stone(Stone.Color.BLACK, Stone.Type.MAN)),
        Map.entry( 4, new Stone(Stone.Color.BLACK, Stone.Type.MAN)),
        Map.entry( 5, new Stone(Stone.Color.BLACK, Stone.Type.MAN)),
        Map.entry( 6, new Stone(Stone.Color.BLACK, Stone.Type.MAN)),
        Map.entry( 7, new Stone(Stone.Color.BLACK, Stone.Type.MAN)),
        Map.entry( 8, new Stone(Stone.Color.BLACK, Stone.Type.MAN)),
        Map.entry( 9, new Stone(Stone.Color.BLACK, Stone.Type.MAN)),
        Map.entry(10, new Stone(Stone.Color.BLACK, Stone.Type.MAN)),
        Map.entry(11, new Stone(Stone.Color.BLACK, Stone.Type.MAN)),
        Map.entry(12, new Stone(Stone.Color.BLACK, Stone.Type.MAN)),

        Map.entry(21, new Stone(Stone.Color.WHITE, Stone.Type.MAN)),
        Map.entry(22, new Stone(Stone.Color.WHITE, Stone.Type.MAN)),
        Map.entry(23, new Stone(Stone.Color.WHITE, Stone.Type.MAN)),
        Map.entry(24, new Stone(Stone.Color.WHITE, Stone.Type.MAN)),
        Map.entry(25, new Stone(Stone.Color.WHITE, Stone.Type.MAN)),
        Map.entry(26, new Stone(Stone.Color.WHITE, Stone.Type.MAN)),
        Map.entry(27, new Stone(Stone.Color.WHITE, Stone.Type.MAN)),
        Map.entry(28, new Stone(Stone.Color.WHITE, Stone.Type.MAN)),
        Map.entry(29, new Stone(Stone.Color.WHITE, Stone.Type.MAN)),
        Map.entry(30, new Stone(Stone.Color.WHITE, Stone.Type.MAN)),
        Map.entry(31, new Stone(Stone.Color.WHITE, Stone.Type.MAN)),
        Map.entry(32, new Stone(Stone.Color.WHITE, Stone.Type.MAN))
    );
}
