package djmil.cordacheckers;

import net.corda.v5.application.flows.CordaInject;
import net.corda.v5.application.membership.MemberLookup;
import net.corda.v5.base.types.MemberX500Name;
import net.corda.v5.membership.MemberInfo;
import net.corda.v5.membership.NotaryInfo;

public class VNode {
    static final String CHECKERS = "Checkers";      // O aka Organization
    static final String PLAYER = "Player";          // OU aka OrganizationUnit
    static final String CUSTODIAN = "Custodian";    // OU aka OrganizationUnit
    static final String NOTARY = "Notary";          // OU aka OrganizationUnit

    @CordaInject
    MemberLookup memberLookup;

    public static boolean isCordaCherckersPlayer(MemberInfo memberInfo) {
        final MemberX500Name memberName = memberInfo.getName();

        return memberName.getOrganization().equals(CHECKERS) && 
               memberName.getOrganizationUnit().equals(PLAYER);
    }

    public static boolean isCordaCherckersCustodian(MemberInfo memberInfo) {
        final MemberX500Name memberName = memberInfo.getName();

        return memberName.getOrganization().equals(CHECKERS) && 
               memberName.getOrganizationUnit().equals(CUSTODIAN);
    }

    public static boolean isCordaCherckersNotary(NotaryInfo notaryInfo) {
        final MemberX500Name memberName = notaryInfo.getName();
        
        return memberName.getOrganization().equals(CHECKERS) && 
               memberName.getOrganizationUnit().equals(NOTARY);
    }

}
