import { usePolling } from "../hook/api";

export default function useUserApi(userReducer) {
    const [user, dispatchUser] = userReducer;

    const useGetUser = () => {
        const onSuccess = (userJson) => {
            dispatchUser({ type: "parse", userJson });
        }

        usePolling('/api/user', onSuccess); // <<-- fetch once

        return user;
    }

    return {
        getUser: useGetUser
    }
}