export function nextState(state, action) {
    const nextState = { ...state };

    Object.keys(action)
        .slice(1) // skip first property i.e. 'next'
        .forEach(key => {
            if (Object.hasOwn(nextState, key)) {
                console.log("next [", key, "] = ", action[key]);
                nextState[key] = action[key];
            } else {
                console.warn("nextState: bad action property\n", key + ":", action[key]);
            }
        })

    return nextState;
}

const StateHelper = {
    next: nextState
};

export default StateHelper;